;; select.scm - Select a back end.
;; Written by Tom Tromey <tromey@cygnus.com>

(define (is-backend-name? name)
  (or
   (equal? name "debian")
   (equal? name "rpm")))

(define (make-package type package-name)
  (cond
   ((equal? type "debian")
    (make-debian-package package-name))

   ((equal? type "rpm")
    (make-rpm-package package-name))

   (#t
    (error "unrecognized package type"))))
